/*
 * -----------------------------------------------------------------------
 *
 * NOTE: Do *not* edit this file; instead, edit 'erl_alloc.types' and
 *       build again! This file was automatically generated by
 *       'make_alloc_types' on Sun Oct  9 07:59:58 2011.
 *
 * -----------------------------------------------------------------------
 *
 * 
 * Copyright Ericsson AB 2011. All Rights Reserved.
 * 
 * The contents of this file are subject to the Erlang Public License,
 * Version 1.1, (the "License"); you may not use this file except in
 * compliance with the License. You should have received a copy of the
 * Erlang Public License along with this software. If not, it can be
 * retrieved online at http://www.erlang.org/.
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific language governing rights and limitations
 * under the License.
 * 
 */

#ifndef ERL_ALLOC_TYPES_H__
#define ERL_ALLOC_TYPES_H__


/* --- Allocator numbers -------------------------------------------------- */

#define ERTS_ALC_A_INVALID (0)

#define ERTS_ALC_A_MIN (1)

#define ERTS_ALC_A_SYSTEM (1)
#define ERTS_ALC_A_SBMBC (2)
#define ERTS_ALC_A_TEMPORARY (3)
#define ERTS_ALC_A_SHORT_LIVED (4)
#define ERTS_ALC_A_STANDARD (5)
#define ERTS_ALC_A_LONG_LIVED (6)
#define ERTS_ALC_A_EHEAP (7)
#define ERTS_ALC_A_ETS (8)
#define ERTS_ALC_A_FIXED_SIZE (9)
#define ERTS_ALC_A_BINARY (10)
#define ERTS_ALC_A_DRIVER (11)

#define ERTS_ALC_A_MAX (11)


/* --- Class numbers ------------------------------------------------------ */

#define ERTS_ALC_C_INVALID (0)

#define ERTS_ALC_C_MIN (1)

#define ERTS_ALC_C_PROCESSES  (1)
#define ERTS_ALC_C_ETS  (2)
#define ERTS_ALC_C_BINARIES  (3)
#define ERTS_ALC_C_ATOM  (4)
#define ERTS_ALC_C_SYSTEM  (5)
#define ERTS_ALC_C_CODE  (6)

#define ERTS_ALC_C_MAX (6)


/* --- Type number intervals ---------------------------------------------- */

#define ERTS_ALC_N_INVALID (0)

#define ERTS_ALC_N_MIN (1)

/* Type numbers used for sys_alloc */
#define ERTS_ALC_N_MIN_A_SYSTEM (1)
#define ERTS_ALC_N_MAX_A_SYSTEM (5)

/* Type numbers used for sbmbc_alloc */
#define ERTS_ALC_N_MIN_A_SBMBC (6)
#define ERTS_ALC_N_MAX_A_SBMBC (6)

/* Type numbers used for temp_alloc */
#define ERTS_ALC_N_MIN_A_TEMPORARY (7)
#define ERTS_ALC_N_MAX_A_TEMPORARY (26)

/* Type numbers used for sl_alloc */
#define ERTS_ALC_N_MIN_A_SHORT_LIVED (27)
#define ERTS_ALC_N_MAX_A_SHORT_LIVED (50)

/* Type numbers used for std_alloc */
#define ERTS_ALC_N_MIN_A_STANDARD (51)
#define ERTS_ALC_N_MAX_A_STANDARD (85)

/* Type numbers used for ll_alloc */
#define ERTS_ALC_N_MIN_A_LONG_LIVED (86)
#define ERTS_ALC_N_MAX_A_LONG_LIVED (117)

/* Type numbers used for eheap_alloc */
#define ERTS_ALC_N_MIN_A_EHEAP (118)
#define ERTS_ALC_N_MAX_A_EHEAP (121)

/* Type numbers used for ets_alloc */
#define ERTS_ALC_N_MIN_A_ETS (122)
#define ERTS_ALC_N_MAX_A_ETS (129)

/* Type numbers used for fix_alloc */
#define ERTS_ALC_N_MIN_A_FIXED_SIZE (130)
#define ERTS_ALC_N_MAX_A_FIXED_SIZE (140)

/* Type numbers used for binary_alloc */
#define ERTS_ALC_N_MIN_A_BINARY (141)
#define ERTS_ALC_N_MAX_A_BINARY (142)

/* Type numbers used for driver_alloc */
#define ERTS_ALC_N_MIN_A_DRIVER (143)
#define ERTS_ALC_N_MAX_A_DRIVER (151)

#define ERTS_ALC_N_MAX (151)


/* --- Multi thread use of allocators -------------------------------------- */

#define ERTS_ALC_MTA_SYSTEM (1)
#define ERTS_ALC_MTA_SBMBC (1)
#define ERTS_ALC_MTA_TEMPORARY (0)
#define ERTS_ALC_MTA_SHORT_LIVED (0)
#define ERTS_ALC_MTA_STANDARD (0)
#define ERTS_ALC_MTA_LONG_LIVED (0)
#define ERTS_ALC_MTA_EHEAP (0)
#define ERTS_ALC_MTA_ETS (0)
#define ERTS_ALC_MTA_FIXED_SIZE (0)
#define ERTS_ALC_MTA_BINARY (1)
#define ERTS_ALC_MTA_DRIVER (1)


/* --- Types --------------------------------------------------------------- */

typedef Uint32 ErtsAlcType_t; /* The type used for memory types */

#define ERTS_ALC_T_INVALID (0)

#define ERTS_ALC_T_UNDEF (209)
#define ERTS_ALC_T_NBIF_TABLE (337)
#define ERTS_ALC_T_INFO_DSBUF (465)
#define ERTS_ALC_T_HIPE (593)
#define ERTS_ALC_T_PUTENV_STR (721)
#define ERTS_ALC_T_SBMBC (850)
#define ERTS_ALC_T_TMP_HEAP (915)
#define ERTS_ALC_T_MSG_ROOTS (1043)
#define ERTS_ALC_T_ROOTSET (1171)
#define ERTS_ALC_T_LOADER_TMP (1379)
#define ERTS_ALC_T_NC_TMP (1491)
#define ERTS_ALC_T_TMP (1619)
#define ERTS_ALC_T_DCTRL_BUF (1747)
#define ERTS_ALC_T_TMP_DIST_BUF (1875)
#define ERTS_ALC_T_ESTACK (2003)
#define ERTS_ALC_T_PORT_CALL_BUF (2131)
#define ERTS_ALC_T_DB_TMP (2211)
#define ERTS_ALC_T_DB_MC_STK (2339)
#define ERTS_ALC_T_DB_MS_CMPL_HEAP (2467)
#define ERTS_ALC_T_LOGGER_DSBUF (2643)
#define ERTS_ALC_T_TMP_DSBUF (2771)
#define ERTS_ALC_T_DDLL_TMP_BUF (2899)
#define ERTS_ALC_T_RE_TMP_BUF (3027)
#define ERTS_ALC_T_TEMP_TERM (3155)
#define ERTS_ALC_T_SYS_READ_BUF (3283)
#define ERTS_ALC_T_ENVIRONMENT (3411)
#define ERTS_ALC_T_PEND_SUSPEND (3476)
#define ERTS_ALC_T_PROC_LIST (3604)
#define ERTS_ALC_T_MSG_REF (3732)
#define ERTS_ALC_T_SL_BIF_TIMER (3860)
#define ERTS_ALC_T_DB_FIXATION (4004)
#define ERTS_ALC_T_DB_FIX_DEL (4132)
#define ERTS_ALC_T_DB_MS_RUN_HEAP (4260)
#define ERTS_ALC_T_DB_PROC_CLEANUP (4388)
#define ERTS_ALC_T_PORT_TASK (4564)
#define ERTS_ALC_T_PORT_TASKQ (4692)
#define ERTS_ALC_T_MISC_OP_LIST (4820)
#define ERTS_ALC_T_PORT_NAMES (4948)
#define ERTS_ALC_T_PROCS_TPROC_EL (5012)
#define ERTS_ALC_T_PROCS_CNKINF (5140)
#define ERTS_ALC_T_PROCS_PIDS (5268)
#define ERTS_ALC_T_RE_SUBJECT (5460)
#define ERTS_ALC_T_RE_STACK (5588)
#define ERTS_ALC_T_UNICODE_BUFFER (5716)
#define ERTS_ALC_T_BINARY_BUFFER (5844)
#define ERTS_ALC_T_TMP_CPU_IDS (5972)
#define ERTS_ALC_T_EXT_TERM_DATA (6036)
#define ERTS_ALC_T_ETHR_SL (6228)
#define ERTS_ALC_T_FD_LIST (6356)
#define ERTS_ALC_T_POLLSET_UPDREQ (6484)
#define ERTS_ALC_T_LINK_LH (6549)
#define ERTS_ALC_T_SUSPEND_MON (6677)
#define ERTS_ALC_T_LL_BIF_TIMER (6805)
#define ERTS_ALC_T_REG_TABLE (6997)
#define ERTS_ALC_T_FUN_TABLE (7141)
#define ERTS_ALC_T_DIST_TABLE (7253)
#define ERTS_ALC_T_NODE_TABLE (7381)
#define ERTS_ALC_T_MODULE_REFS (7525)
#define ERTS_ALC_T_DCACHE (7637)
#define ERTS_ALC_T_DIST_ENTRY (7765)
#define ERTS_ALC_T_NODE_ENTRY (7893)
#define ERTS_ALC_T_DRIVER (8021)
#define ERTS_ALC_T_ARG_REG (8085)
#define ERTS_ALC_T_PROC_DICT (8213)
#define ERTS_ALC_T_CALLS_BUF (8341)
#define ERTS_ALC_T_BPD (8533)
#define ERTS_ALC_T_PORT_NAME (8661)
#define ERTS_ALC_T_LINEBUF (8789)
#define ERTS_ALC_T_IOQ (8917)
#define ERTS_ALC_T_BITS_BUF (9045)
#define ERTS_ALC_T_DB_NTAB_ENT (9125)
#define ERTS_ALC_T_DDLL_HANDLE (9301)
#define ERTS_ALC_T_PORT_DATA_LOCK (9429)
#define ERTS_ALC_T_NODES_MON (9493)
#define ERTS_ALC_T_RE_HEAP (9685)
#define ERTS_ALC_T_PSD (9749)
#define ERTS_ALC_T_PRTSD (9941)
#define ERTS_ALC_T_ZLIB (10069)
#define ERTS_ALC_T_ETHR_STD (10197)
#define ERTS_ALC_T_DDLL_PROCESS (10325)
#define ERTS_ALC_T_MONITOR_LH (10389)
#define ERTS_ALC_T_NLINK_LH (10517)
#define ERTS_ALC_T_DB_HEIR_DATA (10661)
#define ERTS_ALC_T_FD_ENTRY_BUF (10837)
#define ERTS_ALC_T_PRT_REP_EXIT (10965)
#define ERTS_ALC_T_ATOM_TXT (11078)
#define ERTS_ALC_T_BIF_TIMER_TABLE (11222)
#define ERTS_ALC_T_ATOM_TABLE (11334)
#define ERTS_ALC_T_EXPORT_TABLE (11494)
#define ERTS_ALC_T_MODULE_TABLE (11622)
#define ERTS_ALC_T_TAINT (11750)
#define ERTS_ALC_T_PROC_TABLE (11798)
#define ERTS_ALC_T_PORT_TABLE (11990)
#define ERTS_ALC_T_TIMER_WHEEL (12118)
#define ERTS_ALC_T_ASYNC_Q (12246)
#define ERTS_ALC_T_DB_TABLES (12326)
#define ERTS_ALC_T_INSTR_INFO (12502)
#define ERTS_ALC_T_SCHDLR_SLP_INFO (12630)
#define ERTS_ALC_T_RUNQS (12758)
#define ERTS_ALC_T_DDLL_ERRCODES (12886)
#define ERTS_ALC_T_PRE_ALLOC_DATA (13014)
#define ERTS_ALC_T_CPUDATA (13142)
#define ERTS_ALC_T_CPU_GRPS_MAP (13270)
#define ERTS_ALC_T_ETHR_LL (13398)
#define ERTS_ALC_T_ARCALLBACK (13526)
#define ERTS_ALC_T_CODE (13670)
#define ERTS_ALC_T_DB_MS_PSDO_PROC (13734)
#define ERTS_ALC_T_SCHDLR_DATA (13910)
#define ERTS_ALC_T_LL_TEMP_TERM (14038)
#define ERTS_ALC_T_DRV_TAB (14166)
#define ERTS_ALC_T_DRV_EV_STATE (14294)
#define ERTS_ALC_T_POLLSET (14422)
#define ERTS_ALC_T_POLL_FDS (14550)
#define ERTS_ALC_T_POLL_RES_EVS (14678)
#define ERTS_ALC_T_FD_STATUS (14806)
#define ERTS_ALC_T_FD_TAB (14934)
#define ERTS_ALC_T_CS_PROG_PATH (15062)
#define ERTS_ALC_T_BEAM_REGISTER (15127)
#define ERTS_ALC_T_HEAP (15255)
#define ERTS_ALC_T_OLD_HEAP (15383)
#define ERTS_ALC_T_HEAP_FRAG (15511)
#define ERTS_ALC_T_DB_SEG (15656)
#define ERTS_ALC_T_DB_SEG_TAB (15784)
#define ERTS_ALC_T_DB_STK (15912)
#define ERTS_ALC_T_DB_TRANS_TAB (16040)
#define ERTS_ALC_T_DB_SEL_LIST (16168)
#define ERTS_ALC_T_DB_DMC_ERROR (16296)
#define ERTS_ALC_T_DB_DMC_ERR_INFO (16424)
#define ERTS_ALC_T_DB_TERM (16552)
#define ERTS_ALC_T_PROC (16665)
#define ERTS_ALC_T_ATOM (16841)
#define ERTS_ALC_T_MODULE (17001)
#define ERTS_ALC_T_REG_PROC (17049)
#define ERTS_ALC_T_FUN_ENTRY (17257)
#define ERTS_ALC_T_DB_TABLE (17321)
#define ERTS_ALC_T_EXPORT (17513)
#define ERTS_ALC_T_MONITOR_SH (17561)
#define ERTS_ALC_T_NLINK_SH (17689)
#define ERTS_ALC_T_DRV_EV_D_STATE (17881)
#define ERTS_ALC_T_DRV_SEL_D_STATE (18009)
#define ERTS_ALC_T_DRV_BINARY (18106)
#define ERTS_ALC_T_BINARY (18234)
#define ERTS_ALC_T_DRV (18395)
#define ERTS_ALC_T_NIF (18523)
#define ERTS_ALC_T_DRV_THR_OPTS (18651)
#define ERTS_ALC_T_DRV_TID (18779)
#define ERTS_ALC_T_DRV_MTX (18907)
#define ERTS_ALC_T_DRV_CND (19035)
#define ERTS_ALC_T_DRV_RWLCK (19163)
#define ERTS_ALC_T_DRV_TSD (19291)
#define ERTS_ALC_T_ASYNC (19419)


/* --- Field sizes, masks, and shifts -------------------------------------- */

#define ERTS_ALC_A_BITS (4)
#define ERTS_ALC_C_BITS (3)
#define ERTS_ALC_N_BITS (8)
#define ERTS_ALC_T_BITS (15)

#define ERTS_ALC_A_MASK (15)
#define ERTS_ALC_C_MASK (7)
#define ERTS_ALC_N_MASK (255)
#define ERTS_ALC_T_MASK (32767)

#define ERTS_ALC_A_SHIFT (0)
#define ERTS_ALC_C_SHIFT (4)
#define ERTS_ALC_N_SHIFT (7)


/* --- Mappings ------------------------------------------------------------ */

/* type -> type number */
#define ERTS_ALC_T2N(T) (((T) >> ERTS_ALC_N_SHIFT) & ERTS_ALC_N_MASK)

/* type -> allocator number */
#define ERTS_ALC_T2A(T) (((T) >> ERTS_ALC_A_SHIFT) & ERTS_ALC_A_MASK)

/* type -> class number */
#define ERTS_ALC_T2C(T) (((T) >> ERTS_ALC_C_SHIFT) & ERTS_ALC_C_MASK)

/* type number -> type */
#define ERTS_ALC_N2T(N) (erts_alc_n2t[(N)])

/* type number -> type description */
#define ERTS_ALC_N2TD(N) (erts_alc_n2td[(N)])

/* type -> type description */
#define ERTS_ALC_T2TD(T) (ERTS_ALC_N2TD(ERTS_ALC_T2N((T))))

/* class number -> class description */
#define ERTS_ALC_C2CD(C) (erts_alc_c2cd[(C)])

/* allocator number -> allocator description */
#define ERTS_ALC_A2AD(A) (erts_alc_a2ad[(A)])

extern const ErtsAlcType_t erts_alc_n2t[];
extern const char *erts_alc_n2td[];
extern const char *erts_alc_c2cd[];
extern const char *erts_alc_a2ad[];

#ifdef ERTS_ALC_INTERNAL__

const ErtsAlcType_t erts_alc_n2t[] = {
  ERTS_ALC_T_INVALID,
  ERTS_ALC_T_UNDEF,
  ERTS_ALC_T_NBIF_TABLE,
  ERTS_ALC_T_INFO_DSBUF,
  ERTS_ALC_T_HIPE,
  ERTS_ALC_T_PUTENV_STR,
  ERTS_ALC_T_SBMBC,
  ERTS_ALC_T_TMP_HEAP,
  ERTS_ALC_T_MSG_ROOTS,
  ERTS_ALC_T_ROOTSET,
  ERTS_ALC_T_LOADER_TMP,
  ERTS_ALC_T_NC_TMP,
  ERTS_ALC_T_TMP,
  ERTS_ALC_T_DCTRL_BUF,
  ERTS_ALC_T_TMP_DIST_BUF,
  ERTS_ALC_T_ESTACK,
  ERTS_ALC_T_PORT_CALL_BUF,
  ERTS_ALC_T_DB_TMP,
  ERTS_ALC_T_DB_MC_STK,
  ERTS_ALC_T_DB_MS_CMPL_HEAP,
  ERTS_ALC_T_LOGGER_DSBUF,
  ERTS_ALC_T_TMP_DSBUF,
  ERTS_ALC_T_DDLL_TMP_BUF,
  ERTS_ALC_T_RE_TMP_BUF,
  ERTS_ALC_T_TEMP_TERM,
  ERTS_ALC_T_SYS_READ_BUF,
  ERTS_ALC_T_ENVIRONMENT,
  ERTS_ALC_T_PEND_SUSPEND,
  ERTS_ALC_T_PROC_LIST,
  ERTS_ALC_T_MSG_REF,
  ERTS_ALC_T_SL_BIF_TIMER,
  ERTS_ALC_T_DB_FIXATION,
  ERTS_ALC_T_DB_FIX_DEL,
  ERTS_ALC_T_DB_MS_RUN_HEAP,
  ERTS_ALC_T_DB_PROC_CLEANUP,
  ERTS_ALC_T_PORT_TASK,
  ERTS_ALC_T_PORT_TASKQ,
  ERTS_ALC_T_MISC_OP_LIST,
  ERTS_ALC_T_PORT_NAMES,
  ERTS_ALC_T_PROCS_TPROC_EL,
  ERTS_ALC_T_PROCS_CNKINF,
  ERTS_ALC_T_PROCS_PIDS,
  ERTS_ALC_T_RE_SUBJECT,
  ERTS_ALC_T_RE_STACK,
  ERTS_ALC_T_UNICODE_BUFFER,
  ERTS_ALC_T_BINARY_BUFFER,
  ERTS_ALC_T_TMP_CPU_IDS,
  ERTS_ALC_T_EXT_TERM_DATA,
  ERTS_ALC_T_ETHR_SL,
  ERTS_ALC_T_FD_LIST,
  ERTS_ALC_T_POLLSET_UPDREQ,
  ERTS_ALC_T_LINK_LH,
  ERTS_ALC_T_SUSPEND_MON,
  ERTS_ALC_T_LL_BIF_TIMER,
  ERTS_ALC_T_REG_TABLE,
  ERTS_ALC_T_FUN_TABLE,
  ERTS_ALC_T_DIST_TABLE,
  ERTS_ALC_T_NODE_TABLE,
  ERTS_ALC_T_MODULE_REFS,
  ERTS_ALC_T_DCACHE,
  ERTS_ALC_T_DIST_ENTRY,
  ERTS_ALC_T_NODE_ENTRY,
  ERTS_ALC_T_DRIVER,
  ERTS_ALC_T_ARG_REG,
  ERTS_ALC_T_PROC_DICT,
  ERTS_ALC_T_CALLS_BUF,
  ERTS_ALC_T_BPD,
  ERTS_ALC_T_PORT_NAME,
  ERTS_ALC_T_LINEBUF,
  ERTS_ALC_T_IOQ,
  ERTS_ALC_T_BITS_BUF,
  ERTS_ALC_T_DB_NTAB_ENT,
  ERTS_ALC_T_DDLL_HANDLE,
  ERTS_ALC_T_PORT_DATA_LOCK,
  ERTS_ALC_T_NODES_MON,
  ERTS_ALC_T_RE_HEAP,
  ERTS_ALC_T_PSD,
  ERTS_ALC_T_PRTSD,
  ERTS_ALC_T_ZLIB,
  ERTS_ALC_T_ETHR_STD,
  ERTS_ALC_T_DDLL_PROCESS,
  ERTS_ALC_T_MONITOR_LH,
  ERTS_ALC_T_NLINK_LH,
  ERTS_ALC_T_DB_HEIR_DATA,
  ERTS_ALC_T_FD_ENTRY_BUF,
  ERTS_ALC_T_PRT_REP_EXIT,
  ERTS_ALC_T_ATOM_TXT,
  ERTS_ALC_T_BIF_TIMER_TABLE,
  ERTS_ALC_T_ATOM_TABLE,
  ERTS_ALC_T_EXPORT_TABLE,
  ERTS_ALC_T_MODULE_TABLE,
  ERTS_ALC_T_TAINT,
  ERTS_ALC_T_PROC_TABLE,
  ERTS_ALC_T_PORT_TABLE,
  ERTS_ALC_T_TIMER_WHEEL,
  ERTS_ALC_T_ASYNC_Q,
  ERTS_ALC_T_DB_TABLES,
  ERTS_ALC_T_INSTR_INFO,
  ERTS_ALC_T_SCHDLR_SLP_INFO,
  ERTS_ALC_T_RUNQS,
  ERTS_ALC_T_DDLL_ERRCODES,
  ERTS_ALC_T_PRE_ALLOC_DATA,
  ERTS_ALC_T_CPUDATA,
  ERTS_ALC_T_CPU_GRPS_MAP,
  ERTS_ALC_T_ETHR_LL,
  ERTS_ALC_T_ARCALLBACK,
  ERTS_ALC_T_CODE,
  ERTS_ALC_T_DB_MS_PSDO_PROC,
  ERTS_ALC_T_SCHDLR_DATA,
  ERTS_ALC_T_LL_TEMP_TERM,
  ERTS_ALC_T_DRV_TAB,
  ERTS_ALC_T_DRV_EV_STATE,
  ERTS_ALC_T_POLLSET,
  ERTS_ALC_T_POLL_FDS,
  ERTS_ALC_T_POLL_RES_EVS,
  ERTS_ALC_T_FD_STATUS,
  ERTS_ALC_T_FD_TAB,
  ERTS_ALC_T_CS_PROG_PATH,
  ERTS_ALC_T_BEAM_REGISTER,
  ERTS_ALC_T_HEAP,
  ERTS_ALC_T_OLD_HEAP,
  ERTS_ALC_T_HEAP_FRAG,
  ERTS_ALC_T_DB_SEG,
  ERTS_ALC_T_DB_SEG_TAB,
  ERTS_ALC_T_DB_STK,
  ERTS_ALC_T_DB_TRANS_TAB,
  ERTS_ALC_T_DB_SEL_LIST,
  ERTS_ALC_T_DB_DMC_ERROR,
  ERTS_ALC_T_DB_DMC_ERR_INFO,
  ERTS_ALC_T_DB_TERM,
  ERTS_ALC_T_PROC,
  ERTS_ALC_T_ATOM,
  ERTS_ALC_T_MODULE,
  ERTS_ALC_T_REG_PROC,
  ERTS_ALC_T_FUN_ENTRY,
  ERTS_ALC_T_DB_TABLE,
  ERTS_ALC_T_EXPORT,
  ERTS_ALC_T_MONITOR_SH,
  ERTS_ALC_T_NLINK_SH,
  ERTS_ALC_T_DRV_EV_D_STATE,
  ERTS_ALC_T_DRV_SEL_D_STATE,
  ERTS_ALC_T_DRV_BINARY,
  ERTS_ALC_T_BINARY,
  ERTS_ALC_T_DRV,
  ERTS_ALC_T_NIF,
  ERTS_ALC_T_DRV_THR_OPTS,
  ERTS_ALC_T_DRV_TID,
  ERTS_ALC_T_DRV_MTX,
  ERTS_ALC_T_DRV_CND,
  ERTS_ALC_T_DRV_RWLCK,
  ERTS_ALC_T_DRV_TSD,
  ERTS_ALC_T_ASYNC,
  ERTS_ALC_T_INVALID
};

const char *erts_alc_n2td[] = {
  "invalid_type",
  "undefined",
  "nbif_tab",
  "info_dsbuf",
  "hipe_data",
  "putenv_string",
  "small_block_mbc",
  "tmp_heap",
  "msg_roots",
  "root_set",
  "loader_tmp",
  "nc_tmp",
  "tmp",
  "dctrl_buf",
  "tmp_dist_buf",
  "estack",
  "port_call_buf",
  "db_tmp",
  "db_mc_stack",
  "db_match_spec_cmpl_heap",
  "logger_dsbuf",
  "tmp_dsbuf",
  "ddll_tmp_buf",
  "re_tmp_buf",
  "temp_term",
  "sys_read_buf",
  "environment",
  "pending_suspend",
  "proc_list",
  "msg_ref",
  "bif_timer_sl",
  "db_fixation",
  "fixed_del",
  "db_match_spec_run_heap",
  "db_proc_cleanup_state",
  "port_task",
  "port_task_queue",
  "misc_op_list",
  "port_names",
  "processes_term_proc_el",
  "processes_chunk_info",
  "processes_pids",
  "re_subject",
  "re_stack",
  "unicode_buffer",
  "binary_buffer",
  "tmp_cpu_ids",
  "external_term_data",
  "ethread_short_lived",
  "fd_list",
  "pollset_update_req",
  "link_lh",
  "suspend_monitor",
  "bif_timer_ll",
  "reg_tab",
  "fun_tab",
  "dist_tab",
  "node_tab",
  "module_refs",
  "dcache",
  "dist_entry",
  "node_entry",
  "driver",
  "arg_reg",
  "proc_dict",
  "calls_buf",
  "bpd",
  "port_name",
  "line_buf",
  "io_queue",
  "bits_buf",
  "db_named_table_entry",
  "ddll_handle",
  "port_data_lock",
  "nodes_monitor",
  "re_heap",
  "process_specific_data",
  "port_specific_data",
  "zlib",
  "ethread_standard",
  "ddll_processes",
  "monitor_lh",
  "nlink_lh",
  "db_heir_data",
  "fd_entry_buf",
  "port_report_exit",
  "atom_text",
  "bif_timer_table",
  "atom_tab",
  "export_tab",
  "module_tab",
  "taint_list",
  "proc_tab",
  "port_tab",
  "timer_wheel",
  "async_queue",
  "db_tabs",
  "instr_info",
  "scheduler_sleep_info",
  "run_queues",
  "ddll_errcodes",
  "pre_alloc_data",
  "cpu_data",
  "cpu_groups_map",
  "ethread_long_lived",
  "async_ready_callback",
  "code",
  "db_match_pseudo_proc",
  "scheduler_data",
  "ll_temp_term",
  "drv_tab",
  "driver_event_state",
  "pollset",
  "poll_fds",
  "poll_result_events",
  "fd_status",
  "fd_tab",
  "cs_prog_path",
  "beam_register",
  "heap",
  "old_heap",
  "heap_frag",
  "db_segment",
  "db_segment_tab",
  "db_stack",
  "db_trans_tab",
  "db_select_list",
  "db_dmc_error",
  "db_dmc_error_info",
  "db_term",
  "proc",
  "atom_entry",
  "module_entry",
  "reg_proc",
  "fun_entry",
  "db_tab",
  "export_entry",
  "monitor_sh",
  "nlink_sh",
  "driver_event_data_state",
  "driver_select_data_state",
  "drv_binary",
  "binary",
  "drv_internal",
  "nif_internal",
  "driver_thread_opts",
  "driver_tid",
  "driver_mutex",
  "driver_cond",
  "driver_rwlock",
  "driver_tsd",
  "async",
  NULL
};

const char *erts_alc_c2cd[] = {
  "invalid_class",
  "process_data",
  "ets_data",
  "binary_data",
  "atom_data",
  "system_data",
  "code_data",
  NULL
};

const char *erts_alc_a2ad[] = {
  "invalid_allocator",
  "sys_alloc",
  "sbmbc_alloc",
  "temp_alloc",
  "sl_alloc",
  "std_alloc",
  "ll_alloc",
  "eheap_alloc",
  "ets_alloc",
  "fix_alloc",
  "binary_alloc",
  "driver_alloc",
  NULL
};

#endif /* #ifdef ERTS_ALC_INTERNAL__ */


/* ------------------------------------------------------------------------- */
#endif /* #ifndef ERL_ALLOC_TYPES_H__ */
